/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32h7rsxx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "Compiler.h"
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */
extern UART_HandleTypeDef hlpuart1;
extern UART_HandleTypeDef huart7;
extern UART_HandleTypeDef huart8;
extern UART_HandleTypeDef huart1;

extern RTC_HandleTypeDef hrtc;
extern I2C_HandleTypeDef hi2c2;
extern SPI_HandleTypeDef hspi2;
extern SPI_HandleTypeDef hspi3;

extern TIM_HandleTypeDef htim1;
extern TIM_HandleTypeDef htim15;
extern TIM_HandleTypeDef htim16;

extern HCD_HandleTypeDef hhcd_USB_OTG_FS;
/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

void HAL_TIM_MspPostInit(TIM_HandleTypeDef *htim);

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);
void MX_USB_OTG_FS_HCD_Init(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define BuzzerCtrl_Pin GPIO_PIN_5
#define BuzzerCtrl_GPIO_Port GPIOE
#define NandFlashCs_Pin GPIO_PIN_4
#define NandFlashCs_GPIO_Port GPIOA
#define HyperRamRST_Pin GPIO_PIN_5
#define HyperRamRST_GPIO_Port GPIOO
#define WIFI_RST_Pin GPIO_PIN_7
#define WIFI_RST_GPIO_Port GPIOC
#define WIFI_CS_Pin GPIO_PIN_0
#define WIFI_CS_GPIO_Port GPIOD
#define WIFI_Notify_Pin GPIO_PIN_1
#define WIFI_Notify_GPIO_Port GPIOD
#define WIFI_Sync_Pin GPIO_PIN_2
#define WIFI_Sync_GPIO_Port GPIOD
#define RS232Ctrl_Pin GPIO_PIN_11
#define RS232Ctrl_GPIO_Port GPIOE
#define LCD_RST_Pin GPIO_PIN_7
#define LCD_RST_GPIO_Port GPIOD
#define TP_RST_Pin GPIO_PIN_2
#define TP_RST_GPIO_Port GPIOF
#define TP_INT_Pin GPIO_PIN_3
#define TP_INT_GPIO_Port GPIOF
#define RS485Ctrl_Pin GPIO_PIN_4
#define RS485Ctrl_GPIO_Port GPIOF

/* USER CODE BEGIN Private defines */
UINT8 Lcd_SetBacklight(UINT8 _valaue);

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
