/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    app_threadx.c
  * @author  MCD Application Team
  * @brief   ThreadX applicative file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2020-2021 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "app_threadx.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "main.h"
#include "Debug.h"
#include "buzzer.h"
#include "app_touchgfx.h"
#include "System.h"

#include "tuyaWifi.h"
#include "OSAL.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
uint8_t g_beepSwtich = 0;
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
	#define  APP_CFG_TASK_GUI_PRIO                          6u
	#define  APP_CFG_TASK_GUI_STK_SIZE                    	(8192 * 10u)

	static  ULONG64    AppTaskGuiStk[APP_CFG_TASK_GUI_STK_SIZE/8];
	static TX_THREAD 	GuiThread;

#define  APP_CFG_TASK_BEEP_PRIO                          7u
#define  APP_CFG_TASK_BEEP_STK_SIZE                    	(2048)

static  ULONG64    AppTaskBeepStk[APP_CFG_TASK_BEEP_STK_SIZE/8];
static TX_THREAD 	BeepThread;

#define  APP_CFG_TASK_LED_PRIO                          7u
#define  APP_CFG_TASK_LED_STK_SIZE                    	(2048)

static  ULONG64    AppTaskLedStk[APP_CFG_TASK_LED_STK_SIZE/8];
static TX_THREAD 	LedThread;

#define  APP_CFG_TASK_WIFI_PRIO                          7u
#define  APP_CFG_TASK_WIFI_STK_SIZE                    	(2048)

static  ULONG64    AppTaskWIFIStk[APP_CFG_TASK_WIFI_STK_SIZE/8];
static TX_THREAD 	WIFIThread;


MSG_T g_wifiMsg;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */
MusicPara_T TAB_CUSTOM_MUSIC[]=
	{
        { DO_HI,		2u,		60}
		,{ EOT,		0u,	0u	}
	};
void StartBeepTask(unsigned long thread_input)
{
	uint8_t flag = 1,cnt = 0,i;
	HAL_TIM_PWM_Start(&htim15, TIM_CHANNEL_2);
	g_beepSwtich = 0;
	HAL_GPIO_WritePin(GPIOE, GPIO_PIN_5, GPIO_PIN_RESET);
    Buzzer_Init();

  for(;;)
  {
	if(g_beepSwtich)
	{
        DEBUG_MSG("Beep Runing\r\n");
        if(g_sysInfo.buzzer)
        {
        	BuzzMusicSet(TAB_CUSTOM_MUSIC);//TAB_KEYERROR_MUSIC
			BuzzOn();
			g_beepSwtich = 0;
			HAL_GPIO_WritePin(GPIOE, GPIO_PIN_5, GPIO_PIN_SET);
        }
        else
        {
        	g_beepSwtich = 0;
        	HAL_GPIO_WritePin(GPIOE, GPIO_PIN_5, GPIO_PIN_RESET);
        }

	}
    Buzzer_Process();
    tx_thread_sleep(10);

  }
}
void StartLedTask(unsigned long thread_input)
{
	uint8_t flag = 0;
    HAL_GPIO_WritePin(RS232Ctrl_GPIO_Port, RS232Ctrl_Pin, GPIO_PIN_SET);
    HAL_GPIO_WritePin(RS485Ctrl_GPIO_Port, RS485Ctrl_Pin, GPIO_PIN_RESET);

  for(;;)
  {
    tx_thread_sleep(500);
	flag++;
	flag %= 2;
	if(flag)
	{
		HAL_TIM_PWM_Start(&htim1, TIM_CHANNEL_1);
		HAL_TIMEx_PWMN_Start(&htim1, TIM_CHANNEL_2);
		HAL_TIMEx_PWMN_Start(&htim1, TIM_CHANNEL_3);

//        HAL_GPIO_WritePin(GPIOB, GPIO_PIN_2|GPIO_PIN_8|GPIO_PIN_9, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOC, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_13, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOD, GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOE, GPIO_PIN_2|GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOF, GPIO_PIN_5, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOG, GPIO_PIN_2, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOM, GPIO_PIN_13|GPIO_PIN_14, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPION, GPIO_PIN_0|GPIO_PIN_7|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_11, GPIO_PIN_SET);
//        HAL_GPIO_WritePin(GPIOO, GPIO_PIN_1, GPIO_PIN_SET);

//        HAL_UART_Transmit(&huart1, "T", 1, 500);
//        HAL_UART_Transmit(&huart7, "2", 1, 500);
//        HAL_UART_Transmit(&huart8, "4", 1, 500);
	}
	else
	{
		HAL_TIM_PWM_Stop(&htim1, TIM_CHANNEL_1);
		HAL_TIMEx_PWMN_Stop(&htim1, TIM_CHANNEL_2);
		HAL_TIMEx_PWMN_Stop(&htim1, TIM_CHANNEL_3);

//        HAL_GPIO_WritePin(GPIOB, GPIO_PIN_2|GPIO_PIN_8|GPIO_PIN_9, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOC, GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_13, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOD, GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOE, GPIO_PIN_2|GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_12|GPIO_PIN_13|GPIO_PIN_14|GPIO_PIN_15, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOF, GPIO_PIN_5, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOG, GPIO_PIN_2, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOM, GPIO_PIN_13|GPIO_PIN_14, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPION, GPIO_PIN_0|GPIO_PIN_7|GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10|GPIO_PIN_11, GPIO_PIN_RESET);
//        HAL_GPIO_WritePin(GPIOO, GPIO_PIN_1, GPIO_PIN_RESET);
	}

  }
}

uint8_t spiRecebuf[2048];

void HAL_SPI_RxCpltCallback(SPI_HandleTypeDef *hspi)
{
	tx_event_flags_set(&g_wifiEvent,OSAL_WIFI_RECE_COMP,TX_OR);
}
void StartWifiTask(unsigned long thread_input)
{
	uint8_t i,wifiSta,buf[10],flag= 0,first;
	uint16_t cmdLen,cnt;
	ULONG wifiEvent,status;

	TuyaWifi_Init();
	first = 0;
  for(;;)
  {
	  if(HAL_GPIO_ReadPin(WIFI_Notify_GPIO_Port, WIFI_Notify_Pin) == GPIO_PIN_RESET)
	  {
			  HAL_GPIO_WritePin(WIFI_CS_GPIO_Port, WIFI_CS_Pin, GPIO_PIN_RESET);
			  //DEBUG_MSG("Wifi Read Data\r\n");
			 //HAL_SPI_Receive(&hspi3, spiRecebuf,2048, 0xffffff);
			 HAL_SPI_Receive_IT(&hspi3, spiRecebuf,2048);
			 //tx_thread_sleep(50);
			 tx_event_flags_get(&g_wifiEvent,OSAL_WIFI_RECE_COMP,TX_OR_CLEAR,&wifiEvent,TX_WAIT_FOREVER);
			  HAL_GPIO_WritePin(WIFI_CS_GPIO_Port, WIFI_CS_Pin, GPIO_PIN_SET);
			  //tx_thread_sleep(100);
			  if((spiRecebuf[0] == 0x55) && (spiRecebuf[1] == 0xAA))
			  {
				  cmdLen = (uint16_t)(((uint16_t)spiRecebuf[4] << 8) | spiRecebuf[5]);
				  if(System_CheckSum(spiRecebuf, (cmdLen + 6)) == spiRecebuf[cmdLen + 6])
				 {
					  DEBUG_MSG("cmd:0x%02X\r\n", spiRecebuf[3]);
					  DEBUG_MSG("cmdLen:%d\r\n", cmdLen);
					  cnt = 0;
					    while(HAL_GPIO_ReadPin(WIFI_Notify_GPIO_Port, WIFI_Notify_Pin) == GPIO_PIN_RESET)
						{
							//Debug_Printf("wait Notify\r\n");
					    	tx_thread_sleep(1);
							cnt++;
					        if(cnt > 500)
					            break;
						}
					  if(spiRecebuf[3] == 0)
					{
						if(first == 0)
						{
							TuyaWifi_HeartBeatResponse(1);
							first = 1;
						}
						else
						{
							TuyaWifi_HeartBeatResponse(0);
						}
					}
					  else if(spiRecebuf[3] == 1)
					{
					  TuyaWifi_ProductInfResponse();
					}
					else if(spiRecebuf[3] == 2)
					{
						TuyaWifi_WorkModeResponse();
					}
					else if(spiRecebuf[3] == 3)
					{

						DEBUG_MSG("wifi status:%d\r\n", spiRecebuf[6]);

						TuyaWifi_WorkStateResponse();

						g_wifiMsg.ucMessageID = QUEUE_MSG_WIFI_STATUS;
						g_wifiMsg.ucData[0] = spiRecebuf[6];

						tx_queue_send(&g_WifiMsgQueue, &g_wifiMsg, TX_WAIT_FOREVER);

					}
					else if(spiRecebuf[3] == 8)
					{
						TuyaWifi_DpBoolUpdate(DPID_BUZZER,g_sysInfo.buzzer);
						TuyaWifi_DpStringUpdate(DPID_MCU_INFO,"STM32H7S7",sizeof("STM32H7S7")); //STRING型数据上报;
						TuyaWifi_DpStringUpdate(DPID_DEVICE_STATUS,"runing",sizeof("runing")); //STRING型数据上报;
						TuyaWifi_DpValueUpdate(DPID_BACKLIGHT,g_sysInfo.backlight); //VALUE型数据上报;
					}
					else if(spiRecebuf[3] == DATA_QUERT_CMD)
					{
						TuyaWifi_DpHandle(&spiRecebuf[6]);
					}
				 }

  //                for(i = 0;i < cmdLen;i++)
  //                {
  //                    Debug_Printf("SPI Receive buf[%d]:%X\r\n", i,spiRecebuf[i + 6]);
  //                }
			  }

	  }
	  else
	  {
		  //DEBUG_MSG("WIFI Idle\r\n");
		status = tx_queue_receive(&g_WifiOperaQueue, &g_wifiMsg, TX_NO_WAIT);
		if (status == TX_SUCCESS)
		{
			if(g_wifiMsg.ucMessageID = QUEUE_MSG_WIFI_RESET)
				TuyaWifi_ResetNetwork(0);
		}
	  }
    tx_thread_sleep(100);

  }
}
/* USER CODE END PFP */

/**
  * @brief  Application ThreadX Initialization.
  * @param memory_ptr: memory pointer
  * @retval int
  */
UINT App_ThreadX_Init(VOID *memory_ptr)
{
  UINT ret = TX_SUCCESS;
  /* USER CODE BEGIN App_ThreadX_MEM_POOL */
  OSAL_QueueCreate();
  /* USER CODE END App_ThreadX_MEM_POOL */

  /* USER CODE BEGIN App_ThreadX_Init */
  tx_thread_create(&GuiThread, (CHAR*)"TouchGFX", TouchGFX_Task, 0,
            AppTaskGuiStk, APP_CFG_TASK_GUI_STK_SIZE,
                                  5, 5,
                                  TX_NO_TIME_SLICE, TX_AUTO_START);
  tx_thread_create(&BeepThread, (CHAR*)"Beep", StartBeepTask, 0,
            AppTaskBeepStk, APP_CFG_TASK_BEEP_STK_SIZE,
                                  APP_CFG_TASK_BEEP_PRIO, APP_CFG_TASK_BEEP_PRIO,
                                  TX_NO_TIME_SLICE, TX_AUTO_START);

  tx_thread_create(&LedThread, (CHAR*)"Led", StartLedTask, 0,
            AppTaskLedStk, APP_CFG_TASK_LED_STK_SIZE,
                                  APP_CFG_TASK_LED_PRIO, APP_CFG_TASK_LED_PRIO,
                                  TX_NO_TIME_SLICE, TX_AUTO_START);

  tx_thread_create(&WIFIThread, (CHAR*)"Wifi", StartWifiTask, 0,
		  AppTaskWIFIStk, APP_CFG_TASK_WIFI_STK_SIZE,
			APP_CFG_TASK_WIFI_PRIO, APP_CFG_TASK_WIFI_PRIO,
                                  TX_NO_TIME_SLICE, TX_AUTO_START);

  /* USER CODE END App_ThreadX_Init */

  return ret;
}

  /**
  * @brief  Function that implements the kernel's initialization.
  * @param  None
  * @retval None
  */
void MX_ThreadX_Init(void)
{
  /* USER CODE BEGIN  Before_Kernel_Start */

  /* USER CODE END  Before_Kernel_Start */

  tx_kernel_enter();

  /* USER CODE BEGIN  Kernel_Start_Error */

  /* USER CODE END  Kernel_Start_Error */
}

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */
