/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * File Name          : STM32TouchController.cpp
  ******************************************************************************
  * This file was created by TouchGFX Generator 4.24.0. This file is only
  * generated once! Delete this file from your project and re-generate code
  * using STM32CubeMX or change this file manually to update it.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* USER CODE BEGIN STM32TouchController */

#include <STM32TouchController.hpp>

#include "main.h"

extern "C" uint8_t g_beepSwtich;
void STM32TouchController::init()
{
    /**
     * Initialize touch controller and driver
     *
     */
	HAL_GPIO_WritePin(TP_RST_GPIO_Port, TP_RST_Pin, GPIO_PIN_SET);
	HAL_Delay(50);
	HAL_GPIO_WritePin(TP_RST_GPIO_Port, TP_RST_Pin, GPIO_PIN_RESET);
	HAL_Delay(80);
	HAL_GPIO_WritePin(TP_RST_GPIO_Port, TP_RST_Pin, GPIO_PIN_SET);
	HAL_Delay(50);
}

bool STM32TouchController::sampleTouch(int32_t& x, int32_t& y)
{
    /**
     * By default sampleTouch returns false,
     * return true if a touch has been detected, otherwise false.
     *
     * Coordinates are passed to the caller by reference by x and y.
     *
     * This function is called by the TouchGFX framework.
     * By default sampleTouch is called every tick, this can be adjusted by HAL::setTouchSampleRate(int8_t);
     *
     */
    static uint8_t touchflag = 0;
	uint8_t touches = 0;
    uint8_t buf[6];

	if(HAL_I2C_Mem_Read(&hi2c2, 0xAA, 0X12, 1, buf, 3, HAL_MAX_DELAY) == HAL_OK)
	{
		touches = (0x80 & buf[0]);
//        INFO_MSG("touches\r\n",touches);
        if (touches > 0)
        {
            x = buf[1] + ((buf[0] & 0X70) << 4);
            y = buf[2] + ((buf[0] & 0X07) << 8);
            //x = (x * 1024) / 600;
            //y = (y * 600) / 1024;
			if(touchflag == 0)
            {
                touchflag = 1;
                g_beepSwtich = 1;
            }
            //INFO_MSG("X:%d Y:%d\r\n",x,y);
			return true;
        }
	}
    touchflag = 0;
    return false;
}

/* USER CODE END STM32TouchController */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
