/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32h7rsxx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */
#define GD25Q_WriteEnable		0x06
#define GD25Q_WriteDisable		0x04
#define GD25Q_ReadStatusReg1		0x05
#define GD25Q_ReadStatusReg2		0x35
#define GD25Q_ReadStatusReg3		0x15
#define GD25Q_WriteStatusReg1    0x01
#define GD25Q_WriteStatusReg2    0x31
#define GD25Q_WriteStatusReg3    0x11
#define GD25Q_ReadData			0x03
#define GD25Q_FastReadData		0x0B
#define WGD25Q_FastReadDual		0x3B
#define GD25Q_PageProgram		0x02
#define GD25Q_BlockErase			0xD8
#define GD25Q_SectorErase		0x20
#define GD25Q_ChipErase			0xC7
#define GD25Q_ManufactDeviceID	0x90
#define GD25Q_JedecDeviceID		0x9F
/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */
extern CRC_HandleTypeDef hcrc;

extern UART_HandleTypeDef hlpuart1;

extern SPI_HandleTypeDef hspi2;

extern XSPI_HandleTypeDef hxspi1;
extern XSPI_HandleTypeDef hxspi2;
/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define BuzzerCtrl_Pin GPIO_PIN_5
#define BuzzerCtrl_GPIO_Port GPIOE
#define NandFlashCs_Pin GPIO_PIN_4
#define NandFlashCs_GPIO_Port GPIOA
#define HyperRamRST_Pin GPIO_PIN_5
#define HyperRamRST_GPIO_Port GPIOO
#define WIFI_RST_Pin GPIO_PIN_7
#define WIFI_RST_GPIO_Port GPIOC
#define WIFI_CS_Pin GPIO_PIN_0
#define WIFI_CS_GPIO_Port GPIOD
#define WIFI_Notify_Pin GPIO_PIN_1
#define WIFI_Notify_GPIO_Port GPIOD
#define WIFI_Sync_Pin GPIO_PIN_2
#define WIFI_Sync_GPIO_Port GPIOD
#define RS232Ctrl_Pin GPIO_PIN_11
#define RS232Ctrl_GPIO_Port GPIOE
#define LCD_RST_Pin GPIO_PIN_7
#define LCD_RST_GPIO_Port GPIOD
#define TP_RST_Pin GPIO_PIN_2
#define TP_RST_GPIO_Port GPIOF
#define TP_INT_Pin GPIO_PIN_3
#define TP_INT_GPIO_Port GPIOF
#define RS485Ctrl_Pin GPIO_PIN_4
#define RS485Ctrl_GPIO_Port GPIOF

/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
