/**************************************************************************/
/*                                                                        */
/*       Copyright (c) Microsoft Corporation. All rights reserved.        */
/*                                                                        */
/*       This software is licensed under the Microsoft Software License   */
/*       Terms for Microsoft Azure RTOS. Full text of the license can be  */
/*       found in the LICENSE file at https://aka.ms/AzureRTOS_EULA       */
/*       and in the root directory of this software.                      */
/*                                                                        */
/**************************************************************************/

#ifndef LX_NAND_HDS007_DRIVER_H
#define LX_NAND_HDS007_DRIVER_H

#ifdef __cplusplus
extern "C" {
#endif

#if 0
/* Includes ------------------------------------------------------------------*/
#include "../levelx/common/inc/lx_api.h"
#else
#include "lx_api.h"
#endif

#include "Debug.h"


#define TOTAL_BLOCKS                        512             /* Number of total blocks */
#define BYTES_PER_PHYSICAL_PAGE             2048             /* Number of bytes per page */
#define SPARE_BYTES_PER_PAGE                64             /* Number of spare bytes per page */
#define PHYSICAL_PAGES_PER_BLOCK            64             /* Number of physical pages per block minimum 2 */

#define SPARE_DATA1_OFFSET                  4             /* Offset of spare data 1 */
#define SPARE_DATA1_LENGTH                  4             /* length of spare data 1 */
#define SPARE_DATA2_OFFSET                  2             /* Offset of spare data 2 */
#define SPARE_DATA2_LENGTH                  2             /* length of spare data 2 */





UINT  lx_stm32_nand_hds007_driver_initialize(LX_NAND_FLASH *nand_flash);



UINT32 NandFlash_Open();
UINT32 NandFlash_close();
UINT32 NandFlash_Read(UINT32 _addr,UINT32 _len,UINT8* _buff);
UINT32 NandFlash_ReadSectors(UINT32 _page,UINT32 _len,UINT8* _buff);

UINT32 NandFlash_Write(UINT32 _addr,UINT32 _len,UINT8* _buff);
UINT32 NandFlash_WriteSectors(UINT32 _page,UINT32 _len,UINT8* _buff);




#ifdef __cplusplus
}
#endif
#endif /* LX_STM32_NAND_DRIVER_H */

