
#include "tuyaWifi.h"

#define PRODUCT_KEY "pshudts2vrsky7fa"    //开发平台创建产品后生成的16位字符产品唯一标识

#define MCU_VER "1.0.0"         //用户的软件版本,用于MCU固件升级,MCU升级版本需修改
//#define CONFIG_MODE     CONFIG_MODE_DEFAULT             //默认工作模式
//#define CONFIG_MODE     CONFIG_MODE_LOWPOWER            //安全模式 (低功耗配网方式)
#define CONFIG_MODE     CONFIG_MODE_SPECIAL             //防误触模式(特殊配网方式)





UINT8 spiSendbuf[2048];
UINT8 wifibuf[128];
UINT8 SPI_Transmit(UINT8 *_buf,UINT32 _len)
{
    uint8_t ret,i;
    uint16_t cnt = 0;
//    Debug_Printf("SPI Transmit\r\n");
//    for(i = 0;i < (spiSendbuf[5] +7);i++)
//        Debug_Printf("%02X ",spiSendbuf[i]);
//    Debug_Printf("\r\n");

    HAL_GPIO_WritePin(WIFI_CS_GPIO_Port, WIFI_CS_Pin, GPIO_PIN_RESET);
    HAL_GPIO_WritePin(WIFI_Sync_GPIO_Port, WIFI_Sync_Pin, GPIO_PIN_RESET);
    while(HAL_GPIO_ReadPin(WIFI_Notify_GPIO_Port, WIFI_Notify_Pin) == GPIO_PIN_SET)
    {
        //Debug_Printf("wait Notify\r\n");
        HAL_Delay(1);
        cnt++;
//        if(cnt > 500)
//            return 1;
    }
    ret = HAL_SPI_Transmit_IT(&hspi3, spiSendbuf,2048);


//    DEBUG_MSG("SPI_Transmit\r\n");
    return 0;
}
void HAL_SPI_TxCpltCallback(SPI_HandleTypeDef *hspi)
{
	HAL_GPIO_WritePin(WIFI_Sync_GPIO_Port, WIFI_Sync_Pin, GPIO_PIN_SET);
	HAL_GPIO_WritePin(WIFI_CS_GPIO_Port, WIFI_CS_Pin, GPIO_PIN_SET);
}
void TuyaWifi_Init(void)
{
	HAL_GPIO_WritePin(WIFI_RST_GPIO_Port, WIFI_RST_Pin, GPIO_PIN_SET);
	HAL_Delay(500);
	HAL_GPIO_WritePin(WIFI_RST_GPIO_Port, WIFI_RST_Pin, GPIO_PIN_RESET);
	HAL_Delay(500);
	HAL_GPIO_WritePin(WIFI_RST_GPIO_Port, WIFI_RST_Pin, GPIO_PIN_SET);
	HAL_Delay(500);
}
UINT8 TuyaWifi_ConfigFrame(UINT8 _ver,UINT8 _cmd,UINT16 _len,UINT8 *_data)
{
	UINT16 i;
	//DEBUG_MSG("_len = %d\r\n",_len);
	spiSendbuf[0] = 0x55;
	spiSendbuf[1] = 0xaa;
	spiSendbuf[2] = _ver;
	spiSendbuf[3] = _cmd;
	spiSendbuf[4] = (_len >> 8) & 0xff;
	spiSendbuf[5] = _len & 0xff;
	for(i = 0;i < _len;i++)
	{
		spiSendbuf[6 + i] = _data[i];
	}
	spiSendbuf[6 + _len] = System_CheckSum(spiSendbuf, (_len + 6));
#if 0
	for(i = 0;i < (_len + 7);i++)
		DEBUG_MSG("spiSendbuf[%d] = 0x%X\r\n",i,spiSendbuf[i]);
#endif
	return 0;
}
UINT8 TuyaWifi_HeartBeatResponse(UINT8 _flag)
{
	TuyaWifi_ConfigFrame(0x03,0,1,&_flag);
	SPI_Transmit(spiSendbuf,0);
	return 0;
}
UINT8 TuyaWifi_ProductInfResponse()
{
	UINT16 cnt;
	cnt = snprintf((char *)&wifibuf[0], 128,(char const *) "{\"p\":\"%s\",\"v\":\"%s\",\"m\":%s}",PRODUCT_KEY,MCU_VER,CONFIG_MODE);

	TuyaWifi_ConfigFrame(3,1,cnt,wifibuf);
	SPI_Transmit(spiSendbuf,0);
	return 0;
}
UINT8 TuyaWifi_WorkModeResponse()
{
	TuyaWifi_ConfigFrame(3,2,0,spiSendbuf);
	SPI_Transmit(spiSendbuf,0);
	return 0;
}
UINT8 TuyaWifi_WorkStateResponse()
{
	TuyaWifi_ConfigFrame(3,3,0,spiSendbuf);
	SPI_Transmit(spiSendbuf,0);
	return 0;
}
UINT8 TuyaWifi_DpBoolUpdate(UINT8 _dpid,UINT8 _value)
{
    wifibuf[0] = _dpid;
    wifibuf[1] = DP_TYPE_BOOL;
    wifibuf[2] = 0;
    wifibuf[3] = 1;
    wifibuf[4] = _value;

	TuyaWifi_ConfigFrame(3,STATE_UPLOAD_CMD,5,wifibuf);
	SPI_Transmit(spiSendbuf,0);
    return 0;
}
UINT8 TuyaWifi_DpValueUpdate(UINT8 _dpid,UINT32 _value)
{
    wifibuf[0] = _dpid;
    wifibuf[1] = DP_TYPE_VALUE;
    wifibuf[2] = 0;
    wifibuf[3] = 4;
    wifibuf[4] = (_value >> 24) & 0xff;
	wifibuf[5] = (_value >> 16) & 0xff;
	wifibuf[6] = (_value >> 8) & 0xff;
	wifibuf[7] = (_value) & 0xff;

	TuyaWifi_ConfigFrame(3,STATE_UPLOAD_CMD,8,wifibuf);
	SPI_Transmit(spiSendbuf,0);
    return 0;
}
UINT8 TuyaWifi_ResetNetwork(UINT8 _value)
{
	wifibuf[0] = _value;
	TuyaWifi_ConfigFrame(3,WIFI_MODE_CMD,1,wifibuf);
	SPI_Transmit(spiSendbuf,0);
    return 0;
}
/**
 * @brief  string型dp数据上传
 * @param[in] {dpid} dpid号
 * @param[in] {value} 当前dp值指针
 * @param[in] {len} 数据长度
 * @return Null
 * @note   Null
 */
UINT8 TuyaWifi_DpStringUpdate(UINT8 _dpid,const UINT8 _value[],UINT16 _len)
{
	UINT16 i = 0;

    wifibuf[0] = _dpid;
	wifibuf[1] = DP_TYPE_STRING;
	wifibuf[2] = (_len >> 8) & 0xff;
	wifibuf[3] = (_len) & 0xff;
	for(i = 0;i < _len;i++)
		wifibuf[4 + i] = _value[i];

	TuyaWifi_ConfigFrame(3,STATE_UPLOAD_CMD,(4 + _len),wifibuf);
	SPI_Transmit(spiSendbuf,0);

    return SUCCESS;
}
extern uint8_t g_beepSwtich;
UINT8 TuyaWifi_DpHandle(UINT8 value[])
{
	UINT8 dp_id,index;
	UINT8 dp_type;
	UINT8 ret;
	UINT16 dp_len;
	UINT32 val;

    dp_id = value[0];
    dp_type = value[1];
    dp_len = value[2] * 0x100;
    dp_len += value[3];

    switch(dp_id)
    {
    	case	DPID_MCU_INFO:

    	break;
    	case	DPID_DEVICE_STATUS:

    	    	break;
    	case	DPID_BACKLIGHT:
    		val = (UINT32)(value[4] << 24) | (value[5] >> 16) | (value[6] >> 8)|(value[7]);
    		DEBUG_MSG("backlight = %d\r\n",val);
    		g_sysInfo.backlight = val;
    		Lcd_SetBacklight(g_sysInfo.backlight);
    	    	break;
    	case	DPID_BUZZER:
    		if(value[4])
    		{

    			DEBUG_MSG("Buzzer ON\r\n");
    			g_sysInfo.buzzer = 1;
    			g_beepSwtich = 1;
    		}
    		else
    		{
    			DEBUG_MSG("Buzzer OFF\r\n");
    			g_sysInfo.buzzer = 0;
    		}
    	    	break;
    }

    return 0;
}




