#ifndef __COMPILER_H
#define __COMPILER_H

#ifdef __cplusplus
 extern "C" {
#endif

#include <stdio.h>
#include <string.h>
#include "main.h"


/* ȫжϵĺ */
#define ENABLE_INT()	__set_PRIMASK(0)	/* ʹȫж */
#define DISABLE_INT()	__set_PRIMASK(1)	/* ֹȫж */

/*
*	Զӵַ
*/
#define LINK_LOCATION(name) __attribute__((section(name))) __attribute__((aligned(4)))
/*
*	Զʼεַ
*/
typedef void (*initCall_t)(void);	 /*ʼָ*/
	 
#define	_INIT_CALL_NAME(_fun,_level)	_initCall_##_fun##_level
#define _INIT_CALL_SECTION(_level)		__attribute__(( section( "InitCall"#_level))) __attribute__((aligned(4)))

#define	_DEFINE_INIT_CALL(_fun,_level)	const initCall_t _INIT_CALL_SECTION(_level) _INIT_CALL_NAME(_fun,_level) = _fun;

#define	LOW_INIT(_fun)		_DEFINE_INIT_CALL(_fun,0)
#define	SYS_INIT(_fun)		_DEFINE_INIT_CALL(_fun,1)
#define	DEV_INIT(_fun)		_DEFINE_INIT_CALL(_fun,2)
#define	MODULE_INIT(_fun)	_DEFINE_INIT_CALL(_fun,3)
#define	OS_INIT(_fun)		_DEFINE_INIT_CALL(_fun,4)
#define	APP_INIT(_fun)		_DEFINE_INIT_CALL(_fun,5)

	
#define	INIT_SECTION_START	&Image$$Init_Call$$Base
#define	INIT_SECTION_END	&Image$$Init_Call$$Limit

#define _FIRMW_VERSION_CALL_SECTION()		__attribute__(( section( "FirmwareVersion"))) __attribute__((aligned(4)))
#define _SOFT_VERSION_CALL_SECTION()		__attribute__(( section( "SoftVersion"))) __attribute__((aligned(4)))
#define _OTHER_VERSION_CALL_SECTION()		__attribute__(( section( "OtherVersion"))) __attribute__((aligned(4)))

#define	FWARE_VERSION(_MAIN,_MINOR,_LOW)	const unsigned int _FIRMW_VERSION_CALL_SECTION()	_fwareVersion =	((_MAIN << 16)|(_MINOR<<8)|_LOW);
#define	SOFT_VERSION(_MAIN,_MINOR,_LOW)		const unsigned int _SOFT_VERSION_CALL_SECTION() 	_softVersion = 	((_MAIN << 16)|(_MINOR<<8)|_LOW);
#define	OTHER_VERSION(_MAIN,_MINOR,_LOW)	const unsigned int _OTHER_VERSION_CALL_SECTION()	_otherVersion = ((_MAIN << 16)|(_MINOR<<8)|_LOW);

typedef enum{
	INT_NULL 	= 0,   //ûж
  	INT_FALL   	= 1,  //½
  	INT_RISING  = 2,  //
}IntType_E;



/* type definitions */
typedef unsigned char          	UINT8;
typedef unsigned short         	UINT16;
typedef unsigned int           	UINT32;
typedef signed char            	INT8;
typedef signed short           	INT16;
typedef signed int             	INT32;

typedef unsigned long      		UINT64;
typedef signed long        		INT64;

typedef volatile INT32 			Atomic;
typedef volatile INT64 			Atomic64;

typedef unsigned char          	UCHAR;
typedef unsigned short         	USHORT;
typedef unsigned int           	UINT;
typedef char                  	CHAR;
typedef short                  	SHORT;
typedef int                    	INT;
typedef float                  	FLOAT;
typedef double                 	DOUBLE;

typedef unsigned long     	  	ULONG;
typedef signed long       		LONG;
typedef unsigned int           	UINTPTR;
typedef signed int             	INTPTR;


#define VOID          void

#ifndef FALSE
#define FALSE         ((BOOL)0)
#endif

#ifndef TRUE
#define TRUE          ((BOOL)1)
#endif

#ifndef NULL
#ifdef __cplusplus
#define NULL          0L
#else
#define NULL          ((void*)0)
#endif
#endif

#define NULL_BYTE  ((UINT8)0xFF)
#define NULL_SHORT ((UINT16)0xFFFF)
#define NULL_INT   ((UINT32)0xFFFFFFFF)

#ifndef OK
#define OK        0U
#endif

#ifndef NOK
#define NOK       1U
#endif

#ifndef EER
#define EER				0xFFFFFFFFU
#endif

#define SYS_FAIL       1
#define SYS_ERROR      (UINT32)(-1)
#define SYS_INVALID    (UINT32)(-1)
#define SYS_64BIT_MAX  (0xFFFFFFFFFFFFFFFFULL)

/*
*	һЩõͶ̹ؼ
*/
typedef 		uint32_t 	u32;
typedef 		uint16_t 	u16;
typedef 		uint8_t  	u8;

typedef 		int32_t		s32;
typedef 		int16_t 	s16;
typedef 		int8_t  	s8;

typedef	const	int32_t 	sc32;
typedef const 	int16_t 	sc16;
typedef const 	int8_t 		sc8;

typedef __IO 	int32_t 	vs32;
typedef __IO 	int16_t 	vs16;
typedef __IO 	int8_t  	vs8;

typedef __I 	int32_t 	vsc32;
typedef __I 	int16_t 	vsc16;
typedef __I 	int8_t 		vsc8;

typedef const 	uint32_t 	uc32;
typedef const 	uint16_t 	uc16;
typedef const 	uint8_t		uc8;

typedef __IO 	uint32_t 	vu32;
typedef __IO 	uint16_t 	vu16;
typedef __IO 	uint8_t  	vu8;

typedef __I 	uint32_t 	vuc32;
typedef __I 	uint16_t 	vuc16;
typedef __I 	uint8_t 	vuc8;


#ifdef __cplusplus
}
#endif
#endif

